

<template>
    <div class="modal" v-if="isVisible">
        <div class="modal-background" @click="close"></div>
        <div class="modal-content">
            <form class="form"
                  novalidate
                  @submit.prevent="handleSubmit"
                  enctype="multipart/form-data">

                <PlanBaseForm :plan="plan"
                              :title="t('plan.info')"
                              nom-label="plan.nom"
                              largeur-label="plan.largeur"
                              longueur-label="plan.longueur"
                              @handle-validation="handleValidation"
                              @register-form-input-ref="addFormInputRef">

                </PlanBaseForm>
                <FormRow>


                    <button v-if="!props.plan" class=" form__submit btn btn--fullscreen" type="submit">
                        {{ t("global.add") }}
                    </button>

                    <button v-else class=" form__submit btn btn--fullscreen" type="submit">
                        {{ t("global.save") }}
                    </button>

                    <button v-if="!props.plan" class=" form__submit btn btn--fullscreen" type="button" @click="close">{{t("global.cancel")}}</button>
                    <button v-else class=" form__submit btn btn--fullscreen" type="button" @click="hdelete">
                        {{ t("global.delete") }}
                    </button>
                </FormRow>


            </form>
        </div>
    </div>
</template>

<script lang="ts" setup>
    import FormInput from "@/components/forms/FormInput.vue"
    import FormRow from "@/components/forms/FormRow.vue"
    import PlanBaseForm from "@/components/plan/PlanBaseFormAjout.vue"
    import { ref, watch } from "vue"
    import { useI18n } from "vue3-i18n"
    import { notifyError } from "@/notify"
    import { Status } from "@/validation"
    import { PLan } from "@/types/entities"

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        plan?: PLan,
        isVisible: boolean
    }>()


    // eslint-disable-next-line
    const emit = defineEmits<{
        (event: "formSubmit", plan: PLan): void
        (event: "update:isVisible", value: boolean): void
        (event: "formDelete", idPlan: string): void

    }>()



    const close = () => {
        emit('update:isVisible', false);

    };

    const { t } = useI18n()

    const plan = ref<PLan>(props.plan?.id ? props.plan : {})


    watch(() => props.plan, (newVal) => {

        console.log(newVal)
        plan.value = newVal?.id ? newVal : {};
    });


    const formInputs = ref<any[]>([])
    const inputValidationStatuses: any = {}


    function addFormInputRef(ref: typeof FormInput) {
        if (!formInputs.value.includes(ref) && ref)
            formInputs.value.push(ref)
    }


    async function handleValidation(name: string, validationStatus: Status) {
        inputValidationStatuses[name] = validationStatus.valid
    }

    async function handleSubmit() {
        formInputs.value.forEach((x: typeof FormInput) => x.validateInput())
        if (Object.values(inputValidationStatuses).some(x => x === false)) {
            notifyError(t('global.formErrorNotification'))
            return
        }
        emit("formSubmit", plan.value)
    }

    function hdelete() {
        emit("formDelete", plan.value.id!)
    }
</script>
<style scoped>
    .modal {
        position: fixed;
        z-index: 9998;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background-color: rgba(0, 0, 0, 0.6);
        display: flex;
        justify-content: center;
        align-items: center;
    }

    .modal-background {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
    }

    .modal-content {
        z-index: 9999;
        background: white;
        padding: 20px;
        border-radius: 5px;
        box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
    }
</style>